diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-capabilities.h ns-3.43/src/wifi/model/he/he-capabilities.h
--- ns-3.42/src/wifi/model/he/he-capabilities.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-capabilities.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-configuration.cc ns-3.43/src/wifi/model/he/he-configuration.cc
--- ns-3.42/src/wifi/model/he/he-configuration.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-configuration.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
@@ -188,8 +177,8 @@
 HeConfiguration::SetGuardInterval(Time guardInterval)
 {
     NS_LOG_FUNCTION(this << guardInterval);
-    NS_ASSERT(guardInterval == NanoSeconds(800) || guardInterval == NanoSeconds(1600) ||
-              guardInterval == NanoSeconds(3200));
+    [[maybe_unused]] const auto gi = guardInterval.GetNanoSeconds();
+    NS_ASSERT((gi == 800) || (gi == 1600) || (gi == 3200));
     m_guardInterval = guardInterval;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-configuration.h ns-3.43/src/wifi/model/he/he-configuration.h
--- ns-3.42/src/wifi/model/he/he-configuration.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-configuration.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.43/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.42/src/wifi/model/he/he-frame-exchange-manager.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-frame-exchange-manager.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -399,6 +388,15 @@
 HeFrameExchangeManager::CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << *muRts << txVector);
+    DoCtsAfterMuRtsTimeout(muRts, txVector, true);
+}
+
+void
+HeFrameExchangeManager::DoCtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts,
+                                               const WifiTxVector& txVector,
+                                               bool updateFailedCw)
+{
+    NS_LOG_FUNCTION(this << *muRts << txVector << updateFailedCw);
 
     if (m_psduMap.empty())
     {
@@ -446,7 +444,10 @@
     else
     {
         NS_LOG_DEBUG("Missed CTS, retransmit MPDUs");
-        m_edca->UpdateFailedCw(m_linkId);
+        if (updateFailedCw)
+        {
+            m_edca->UpdateFailedCw(m_linkId);
+        }
     }
     // Make the sequence numbers of the MPDUs available again if the MPDUs have never
     // been transmitted, both in case the MPDUs have been discarded and in case the
@@ -1189,7 +1190,7 @@
 
     auto userInfoIt = trigger.FindUserInfoWithAid(staId);
     NS_ASSERT_MSG(userInfoIt != trigger.end(), "User Info field for AID=" << staId << " not found");
-    uint16_t bw = 0;
+    MHz_u bw = 0;
 
     if (uint8_t ru = userInfoIt->GetMuRtsRuAllocation(); ru < 65)
     {
@@ -1488,39 +1489,38 @@
         trigger.GetApTxPower() -
         static_cast<int8_t>(
             *optRssi); // cast RSSI to be on equal footing with AP Tx power information
-    auto reqTxPowerDbm = static_cast<double>(userInfoIt->GetUlTargetRssi() + pathLossDb);
+    auto reqTxPower = static_cast<dBm_u>(userInfoIt->GetUlTargetRssi() + pathLossDb);
 
     // Convert the transmit power to a power level
     uint8_t numPowerLevels = m_phy->GetNTxPower();
     if (numPowerLevels > 1)
     {
-        double stepDbm = (m_phy->GetTxPowerEnd() - m_phy->GetTxPowerStart()) / (numPowerLevels - 1);
+        dBm_u step = (m_phy->GetTxPowerEnd() - m_phy->GetTxPowerStart()) / (numPowerLevels - 1);
         powerLevel = static_cast<uint8_t>(
-            ceil((reqTxPowerDbm - m_phy->GetTxPowerStart()) /
-                 stepDbm)); // better be slightly above so as to satisfy target UL RSSI
+            ceil((reqTxPower - m_phy->GetTxPowerStart()) /
+                 step)); // better be slightly above so as to satisfy target UL RSSI
         if (powerLevel > numPowerLevels)
         {
             powerLevel = numPowerLevels; // capping will trigger warning below
         }
     }
-    if (reqTxPowerDbm > m_phy->GetPowerDbm(powerLevel))
+    if (reqTxPower > m_phy->GetPower(powerLevel))
     {
-        NS_LOG_WARN("The requested power level ("
-                    << reqTxPowerDbm << "dBm) cannot be satisfied (max: " << m_phy->GetTxPowerEnd()
-                    << "dBm)");
+        NS_LOG_WARN("The requested power level (" << reqTxPower << "dBm) cannot be satisfied (max: "
+                                                  << m_phy->GetTxPowerEnd() << "dBm)");
     }
     v.SetTxPowerLevel(powerLevel);
     NS_LOG_LOGIC("UL power control: "
-                 << "input {pathLoss=" << pathLossDb << "dB, reqTxPower=" << reqTxPowerDbm << "dBm}"
-                 << " output {powerLevel=" << +powerLevel << " -> "
-                 << m_phy->GetPowerDbm(powerLevel) << "dBm}"
+                 << "input {pathLoss=" << pathLossDb << "dB, reqTxPower=" << reqTxPower << "dBm}"
+                 << " output {powerLevel=" << +powerLevel << " -> " << m_phy->GetPower(powerLevel)
+                 << "dBm}"
                  << " PHY power capa {min=" << m_phy->GetTxPowerStart() << "dBm, max="
                  << m_phy->GetTxPowerEnd() << "dBm, levels:" << +numPowerLevels << "}");
 
     return v;
 }
 
-std::optional<double>
+std::optional<dBm_u>
 HeFrameExchangeManager::GetMostRecentRssi(const Mac48Address& address) const
 {
     return GetWifiRemoteStationManager()->GetMostRecentRssi(address);
@@ -1533,7 +1533,7 @@
     NS_ASSERT(m_apMac);
 
     trigger.SetApTxPower(static_cast<int8_t>(
-        m_phy->GetPowerDbm(GetWifiRemoteStationManager()->GetDefaultTxPowerLevel())));
+        m_phy->GetPower(GetWifiRemoteStationManager()->GetDefaultTxPowerLevel())));
     for (auto& userInfo : trigger)
     {
         const auto staList = m_apMac->GetStaList(m_linkId);
@@ -1830,9 +1830,11 @@
         return;
     }
 
+    const auto addr1 =
+        GetWifiRemoteStationManager()->GetMldAddress(hdr.GetAddr2()).value_or(hdr.GetAddr2());
     WifiMacHeader header(WIFI_MAC_QOSDATA_NULL);
-    header.SetAddr1(hdr.GetAddr2());
-    header.SetAddr2(m_self);
+    header.SetAddr1(addr1);
+    header.SetAddr2(m_mac->GetAddress());
     header.SetAddr3(hdr.GetAddr2());
     header.SetDsTo();
     header.SetDsNotFrom();
@@ -1869,6 +1871,7 @@
         // TX parameters below.
         header.SetQosTid(tid);
         auto mpdu = Create<WifiMpdu>(Create<Packet>(), header);
+        mpdu = CreateAliasIfNeeded(mpdu);
         txParams.AddMpdu(mpdu);
         UpdateTxDuration(header.GetAddr1(), txParams);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-frame-exchange-manager.h ns-3.43/src/wifi/model/he/he-frame-exchange-manager.h
--- ns-3.42/src/wifi/model/he/he-frame-exchange-manager.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-frame-exchange-manager.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -110,13 +99,13 @@
     virtual void SetTargetRssi(CtrlTriggerHeader& trigger) const;
 
     /**
-     * Get the RSSI (in dBm) of the most recent packet received from the station having
+     * Get the RSSI of the most recent packet received from the station having
      * the given address.
      *
      * \param address of the remote station
-     * \return the RSSI (in dBm) of the most recent packet received from the remote station
+     * \return the RSSI of the most recent packet received from the remote station
      */
-    virtual std::optional<double> GetMostRecentRssi(const Mac48Address& address) const;
+    virtual std::optional<dBm_u> GetMostRecentRssi(const Mac48Address& address) const;
 
     /**
      * Return whether the received frame is classified as intra-BSS. It is assumed that
@@ -214,6 +203,17 @@
     virtual void CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector);
 
     /**
+     * Called when no CTS frame is received after an MU-RTS.
+     *
+     * \param muRts the MU-RTS that solicited CTS responses
+     * \param txVector the TXVECTOR used to transmit the MU-RTS frame
+     * \param updateFailedCw whether to update CW in case of retransmission after TX failure
+     */
+    void DoCtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts,
+                                const WifiTxVector& txVector,
+                                bool updateFailedCw);
+
+    /**
      * Send CTS after receiving an MU-RTS.
      *
      * \param muRtsHdr the MAC header of the received MU-RTS
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-operation.cc ns-3.43/src/wifi/model/he/he-operation.cc
--- ns-3.42/src/wifi/model/he/he-operation.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-operation.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
  *          Stefano Avallone <stavallo@unina.it>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-operation.h ns-3.43/src/wifi/model/he/he-operation.h
--- ns-3.42/src/wifi/model/he/he-operation.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-operation.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2017 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sébastien Deronne <sebastien.deronne@gmail.com>
  *          Stefano Avallone <stavallo@unina.it>
